define([
    'jquery',
    'Amasty_Shopby/js/amShopbyAjax'
], function ($) {
    "use strict";

    $.widget('lazyload.amShopbyAjax', $.mage.amShopbyAjax, {
        reloadHtml: function (data) {
            if (data.hasOwnProperty('categoryProducts')) {
                data.categoryProducts = this.replaceImages(data.categoryProducts);
            }
            if (data.hasOwnProperty('bottomCmsBlock')) {
                data.bottomCmsBlock = this.replaceImages(data.bottomCmsBlock);
            }
            this._super(data);
        },

        replaceImages: function (str) {
            let regex   = /<img[^>]+src="([^">]+)"[^\>]+>/g;
            let images  = str.match(regex);
            if (images) {
                images.forEach(image => {
                    let newImage = image.includes('data-src="') ? image.replace('data-src="', 'src="') : image;
                    str = str.replace(image, newImage);
                });
            }

            return str;
        }
    });

    return $.lazyload.amShopbyAjax;
});
